﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PropertyModifiers
{
    public class BaseObject
    {
        protected IProperty<float> weight;


        public BaseObject(IGameService service)
        {
            this.weight = new FloatProperty ();
        }

        public virtual IProperty<float> Weight
        {
            get { return this.weight; }
            set { this.weight = value; }
        }

        // Having an update method on this object is a bad design desision. The reason is, for example with armor/weapon items that have 
        // implemented a Start method, that there could be hundreds if not thousands of objects
        // that inherit from BaseObject and each of there Update methods could be called. A Better system is to have a 
        // event service, and have the object hook into that event service. That way only objects who need to be updated can
        // hook into the nessary events rather then having countless non-implemented Update methods meing called and thus
        // incouring a method call performance penalty overhead. It goes back to that old addage that the fastest code
        // that is run is no code at all.
    }
}
