using System;

namespace PropertyModifiers
{
    public class EventService : IEventService
    {
        public event EventHandler<ItemEventArgs> ItemUpdate;
        public event EventHandler<MessageEventArgs> ItemMessages;

        private readonly ItemEventArgs args = new ItemEventArgs();
        private readonly MessageEventArgs messageArgs = new MessageEventArgs();


        public void Update(TimeSpan gameTime)
        {
            if (this.ItemUpdate != null)
            {
                this.args.gameTime = gameTime;
                this.ItemUpdate(this, this.args);
            }
        }

        public void Report(Category cat, MessageType type, string message)
        {
            this.messageArgs.Category = cat;
            this.messageArgs.Message = message;
            this.messageArgs.MessageType = type;

            switch (cat)
            {
                case Category.Item:
                    if (this.ItemMessages != null) this.ItemMessages(this, this.messageArgs);
                    break;

                case Category.Other:
                default:
                    break;
            }
        }
    }
}