﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PropertyModifiers
{
    public class FloatProperty : IProperty<float>
    {
        private List<IPropertyModifier<float>> modifiers = new List<IPropertyModifier<float>>();
        private float baseValue = default(float);


        public FloatProperty()
        {

        }

        public FloatProperty(float basevalue)
            : this()
        {
            this.baseValue = basevalue;
        }

        public virtual float Value
        {
            get
            {
                var value = this.baseValue;
                foreach (var modifier in modifiers)
                {
                    value += modifier.Value;
                }
                return value;
            }
        }

        public virtual float BaseValue
        {
            get { return this.baseValue; }
            set { this.baseValue = value; }
        }

        public List<IPropertyModifier<float>> Modifiers
        {
            get { return this.modifiers; }
        }

        //public void Update(TimeSpan gameTime)
        //{
        //
        //}
    }
}
