﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PropertyModifiers
{
    public interface IUseable
    {
        void Start();
        void Stop();
        string GetDescription();
        TimeSpan RemainingTimeOnCooldown { get; }
        TimeSpan Cooldown { get; }
        int Charges { get; }
        void SetCooldown(TimeSpan value);
        void SetDuration(TimeSpan value);
        void SetCharges(int value);

        event EventHandler<UsageEventArgs> StartUsage;
        event EventHandler<UsageEventArgs> StopUsage;
    }
}
