﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PropertyModifiers
{
    public class Item : BaseObject
    {
        protected string description;
        internal protected IUseable useability;
        protected string name;


        public IUseable Useability
        {
            get { return useability; }
            set { useability = value; }
        }

        public Item(IGameService service)
            : base(service)
        {
        }

        /// <summary>
        /// Uses the item.
        /// </summary>
        /// <remarks>Calls the Usability.Start method. Will only work if the Useability property has been setup.</remarks>
        public virtual void Use()
        {
            if (this.useability != null) this.useability.Start();
        }

        public virtual string Name
        {
            get { return this.name; }
            set { this.name = value; }
        }

        public virtual string Description
        {
            get { return this.description + (this.useability != null ? this.useability.GetDescription() : string.Empty); }
            set { this.description = value; }
        }
    }
}
