using System;

namespace PropertyModifiers
{
    public class MessageEventArgs : EventArgs
    {
        protected string message = string.Empty;
        protected MessageType messageType = MessageType.Information;
        private Category category = Category.Other;


        public Category Category
        {
            get { return this.category; }
            set { this.category = value; }
        }

        public MessageType MessageType
        {
            get { return messageType; }
            set { messageType = value; }
        }

        public string Message
        {
            get { return message; }
            set { message = value; }
        }

        public MessageEventArgs(string msg)
        {
            this.message = msg;
        }

        public MessageEventArgs(MessageType type)
        {
            this.messageType = type;
        }

        public MessageEventArgs(MessageType type, string msg)
        {
            this.messageType = type;
            this.message = msg;
        }
        
        public MessageEventArgs()
        {
            
        }
    }
}