namespace PropertyModifiers
{
    public class SteelChest : Armor
    {
        public override ArmorSlots Slot
        {
            get { return ArmorSlots.Chest; }
        }

        public SteelChest(IGameService service) : base(service)
        {
            this.name = "Steel Chest";
            this.description = "Equip: Increases armor by 25 and strength by 10.";
            this.weight.BaseValue = 10;
            this.actorModifiers[ActorProperties.Weight] = new BasicPropertyModifier<float>(this.weight.Value);
            this.actorModifiers[ActorProperties.Armor] = new BasicPropertyModifier<float>(25);
            this.actorModifiers[ActorProperties.Strength] = new BasicPropertyModifier<float>(10);
        }
    }
}